package com.huimv.guowei.admin.controller;


import cn.hutool.core.util.ObjectUtil;
import com.alibaba.druid.util.StringUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.EnergyWarningThreshold;
import com.huimv.guowei.admin.service.IEnergyWarningThresholdService;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@RestController
@RequestMapping("/energy-warning-threshold")
@CrossOrigin
public class EnergyWarningThresholdController {
    @Resource
    private IEnergyWarningThresholdService energyWarningThresholdService;

    @PostMapping("/saveThreshold")
    @Transactional
    //TODO 目前先写死 水线芯片号
    public Result saveThreshold(@RequestBody Map<String ,String> paramsMap){
        String maxWater = paramsMap.get("maxWater");
        String maxEle = paramsMap.get("maxEle");
        String maxWaterLine1 = paramsMap.get("maxWaterLine1");
        String maxWaterLine2 = paramsMap.get("maxWaterLine2");
        String maxWaterLine3 = paramsMap.get("maxWaterLine3");
        String maxWaterLine4 = paramsMap.get("maxWaterLine4");
        String farmId = paramsMap.get("farmId");

        maxWater = nullParameter(maxWater);
        maxEle = nullParameter(maxEle);
        maxWaterLine1 = nullParameter(maxWaterLine1);
        maxWaterLine2 = nullParameter(maxWaterLine2);
        maxWaterLine3 = nullParameter(maxWaterLine3);
        maxWaterLine4 = nullParameter(maxWaterLine4);

        EnergyWarningThreshold energyWarningThreshold0 = new EnergyWarningThreshold();
        energyWarningThreshold0.setMaxValue(maxWater);
        energyWarningThreshold0.setFarmId(Integer.parseInt(farmId));
        energyWarningThreshold0.setWarningType(0);
        energyWarningThresholdService.saveOrUpdate(energyWarningThreshold0,new UpdateWrapper<EnergyWarningThreshold>()
                .eq("farm_id",farmId)
                .eq("warning_type",0));

        EnergyWarningThreshold energyWarningThreshold1 = new EnergyWarningThreshold();
        energyWarningThreshold1.setMaxValue(maxEle);
        energyWarningThreshold1.setFarmId(Integer.parseInt(farmId));
        energyWarningThreshold1.setWarningType(1);
        energyWarningThresholdService.saveOrUpdate(energyWarningThreshold1,new UpdateWrapper<EnergyWarningThreshold>()
                .eq("farm_id",farmId)
                .eq("warning_type",1));

        EnergyWarningThreshold energyWarningThreshold2 = new EnergyWarningThreshold();
        energyWarningThreshold2.setMaxValue(maxWaterLine1);
        energyWarningThreshold2.setFarmId(Integer.parseInt(farmId));
        energyWarningThreshold2.setWarningType(2);
        energyWarningThreshold2.setChipCode("1001");
        energyWarningThresholdService.saveOrUpdate(energyWarningThreshold2,new UpdateWrapper<EnergyWarningThreshold>()
                .eq("farm_id",farmId)
                .eq("warning_type",2).eq("chip_code","1001"));

        EnergyWarningThreshold energyWarningThreshold3 = new EnergyWarningThreshold();
        energyWarningThreshold3.setMaxValue(maxWaterLine2);
        energyWarningThreshold3.setFarmId(Integer.parseInt(farmId));
        energyWarningThreshold3.setWarningType(2);
        energyWarningThreshold3.setChipCode("1002");
        energyWarningThresholdService.saveOrUpdate(energyWarningThreshold3,new UpdateWrapper<EnergyWarningThreshold>()
                .eq("farm_id",farmId)
                .eq("warning_type",2).eq("chip_code","1002"));

        EnergyWarningThreshold energyWarningThreshold4 = new EnergyWarningThreshold();
        energyWarningThreshold4.setMaxValue(maxWaterLine3);
        energyWarningThreshold4.setFarmId(Integer.parseInt(farmId));
        energyWarningThreshold4.setWarningType(2);
        energyWarningThreshold4.setChipCode("1003");
        energyWarningThresholdService.saveOrUpdate(energyWarningThreshold4,new UpdateWrapper<EnergyWarningThreshold>()
                .eq("farm_id",farmId)
                .eq("warning_type",2).eq("chip_code","1003"));

        EnergyWarningThreshold energyWarningThreshold5 = new EnergyWarningThreshold();
        energyWarningThreshold5.setMaxValue(maxWaterLine4);
        energyWarningThreshold5.setFarmId(Integer.parseInt(farmId));
        energyWarningThreshold5.setWarningType(2);
        energyWarningThreshold5.setChipCode("1004");
        energyWarningThresholdService.saveOrUpdate(energyWarningThreshold5,new UpdateWrapper<EnergyWarningThreshold>()
                .eq("farm_id",farmId)
                .eq("warning_type",2).eq("chip_code","1004"));
        return Result.SUCCESS();
    }

    @PostMapping("/getThreshold")
    public Result getThreshold(@RequestBody Map<String ,String> paramsMap){
        String farmId = paramsMap.get("farmId");
        Map resultMap = new HashMap();
        EnergyWarningThreshold waterThreshold = energyWarningThresholdService.getOne(new QueryWrapper<EnergyWarningThreshold>().eq("farm_id", farmId).eq("warning_type", 0));
        if (ObjectUtil.isEmpty(waterThreshold)){
            resultMap.put("maxWater",0);
        }else {
            if(!StringUtils.isEmpty(waterThreshold.getMaxValue())){
                resultMap.put("maxWater", waterThreshold.getMaxValue());
            }else {
                resultMap.put("maxWater",0);
            }
        }
        EnergyWarningThreshold eleThreshold = energyWarningThresholdService.getOne(new QueryWrapper<EnergyWarningThreshold>().eq("farm_id", farmId).eq("warning_type", 1));
        if (ObjectUtil.isEmpty(eleThreshold)){
            resultMap.put("maxEle",0);
        }else {
            if(!StringUtils.isEmpty(eleThreshold.getMaxValue())){
                resultMap.put("maxEle",eleThreshold.getMaxValue());
            }else {
                resultMap.put("maxEle",0);
            }
        }
        //TODO 写死水线芯片号
        EnergyWarningThreshold water1 = energyWarningThresholdService.getOne(new QueryWrapper<EnergyWarningThreshold>().eq("farm_id", farmId).eq("warning_type", 2).eq("chip_code", "1001"));
        if (ObjectUtil.isEmpty(water1)){
            resultMap.put("maxWaterLine1",0);
        }else {
            if(!StringUtils.isEmpty(water1.getMaxValue())){
                resultMap.put("maxWaterLine1",water1.getMaxValue());
            }else {
                resultMap.put("maxWaterLine1",0);
            }
        }
        EnergyWarningThreshold water2 = energyWarningThresholdService.getOne(new QueryWrapper<EnergyWarningThreshold>().eq("farm_id", farmId).eq("warning_type", 2).eq("chip_code", "1002"));
        if (ObjectUtil.isEmpty(water2)){
            resultMap.put("maxWaterLine2",0);
        }else {
            if(!StringUtils.isEmpty(water2.getMaxValue())){
                resultMap.put("maxWaterLine2",water2.getMaxValue());
            }else {
                resultMap.put("maxWaterLine2",0);
            }
        }
        EnergyWarningThreshold water3 = energyWarningThresholdService.getOne(new QueryWrapper<EnergyWarningThreshold>().eq("farm_id", farmId).eq("warning_type", 2).eq("chip_code", "1003"));
        if (ObjectUtil.isEmpty(water3)){
            resultMap.put("maxWaterLine3",0);
        }else {
            if(!StringUtils.isEmpty(water3.getMaxValue())){
                resultMap.put("maxWaterLine3",water3.getMaxValue());
            }else {
                resultMap.put("maxWaterLine3",0);
            }
        }
        EnergyWarningThreshold water4 = energyWarningThresholdService.getOne(new QueryWrapper<EnergyWarningThreshold>().eq("farm_id", farmId).eq("warning_type", 2).eq("chip_code", "1004"));
        if (ObjectUtil.isEmpty(water4)){
            resultMap.put("maxWaterLine4",0);
        }else {
            if(!StringUtils.isEmpty(water4.getMaxValue())){
                resultMap.put("maxWaterLine4",water4.getMaxValue());
            }else {
                resultMap.put("maxWaterLine4",0);
            }
        }

        return new Result(ResultCode.SUCCESS,resultMap);
    }

    public String nullParameter(String param){
        if (StringUtils.isEmpty(param)){
            param = "0";
        }
        return param;
    }


}
